//*****************************************************************//
//AUTO_PIVOT_TRADE                                                 //
//*****************************************************************//
#property copyright " Copyright  2007"
#property link      "..."

#include       <stdlib.mqh>
#include       <stderror.mqh> 
extern int     MAvolume=250;
extern int     CCI_PeriodFast=55;
extern int     cciblock=250;
extern int     StopLoss = 35;
extern int     ProfitTarget = 35;                    // Change to whatever number of pips you wish to trail your position with.
extern double  TrailingStop = 15; 
extern bool    UseEWOExit=true;                    
extern bool    UseTrailingStop = true;
extern bool    UseSupResStop = true;
extern int     TrailingStopType = 2;                 // Type 1 moves stop immediately, Type 2 waits til value of TS is reached
extern double  Lots = 0.1;



extern int     Slippage = 5;
extern int     SignalCandle=1;                       //set to 1 if you want to get the cangle close 0 for current
int err, ticket, MyTrades;
int OpenLong;
int OpenShort;
//+---------------------------------------------------+
//|Money Management                                   |
//+---------------------------------------------------+
extern bool    UseMoneyManagement = false;           // Change to false to shutdown money management controls.
extern int     MM_Type = 1;
//+---------------------------------------------------+
//|Money Management type 1                            |
//+---------------------------------------------------+
extern string  StrSep1 = "-----MoneyManagementType 1 -----";
extern double  MMRisk=0.15;                         // Risk Factor
extern double  LossMax=1000;                        // Maximum Loss by 1 Lot
//+---------------------------------------------------+
//|Money Management type 2                            |
//+---------------------------------------------------+
extern string  StrSep2 = "-----MoneyManagementType 2 -----";
extern bool    AccountIsMini = true;                // Change to true if trading mini account
extern double  TradeSizePercent = 15;               // Change to whatever percent of equity you wish to risk.
double         MaxLots = 10;
//+--------------Is It Time To Trade?----------------------+

extern int     GMT_Offset = 0;
extern string  sm="--Trading Hours--";
extern bool    UseTradingHours = true;
extern bool    TradeAsianMarket = true;
extern int     StartHour1 = 2;       // Start trades after time
extern int     StopHour1 = 10;       // Stop trading after time
extern bool    TradeEuropeanMarket = true;
extern int     StartHour2 = 9;       // Start trades after time
extern int     StopHour2 = 14;       // Stop trading after time
extern bool    TradeNewYorkMarket = false;
extern int     StartHour3 = 15;      // Start trades after time
extern int     StopHour3 = 23;       // Stop trading after time
bool YesStop;
//+---------------------------------------------------------------+//

double PrevDClose=0, PrevDHigh=0, PrevDLow=0, YPivot=0, BarClose=0,BarClosePrev=0,
       PrevBarHigh=0,PrevBarLow=0,Lotsi=0,cci1=0, cci1Prev=0,EWO=0,maLarge=0,Ma8=0,
       Ma55=0,Ma8Prev=0,Ma55Prev=0,RSI=0,RSIPrev=0,PrevDCloseP=0,PrevDHighP=0,PrevDLowP=0;
bool   TradeAllowed=true;
int    MagicNumber;                  // Magic number of the trades. must be unique to identify
 
int init() 
  {
    MagicNumber = 3000 + func_Symbol2Val(Symbol())*100 + func_TimeFrame_Const2Val(Period());
  }

bool CheckTradingTimes()
{
   bool StopTrading;
   int offsetStartHour1, offsetStopHour1;
   int offsetStartHour2, offsetStopHour2;
   int offsetStartHour3, offsetStopHour3;
   
   offsetStartHour1 = StartHour1 + GMT_Offset;
   offsetStopHour1 = StopHour1 + GMT_Offset;
   offsetStartHour2 = StartHour2 + GMT_Offset;
   offsetStopHour2 = StopHour2 + GMT_Offset;
   offsetStartHour3 = StartHour3 + GMT_Offset;
   offsetStopHour3 = StopHour3 + GMT_Offset;
   
     StopTrading = true;
//------------------------------- Check trading Asian Market-------------------------//
     if (TradeAsianMarket)
     {
        if (offsetStartHour1 > 18)
        {
//----------------------- Check broker that uses Asian open before 0:00--------------//

          if (Hour() >= offsetStartHour1) StopTrading = false;
          if (!StopTrading)
          {
            if (offsetStopHour1 < 24)
            {
              if ( Hour() <= offsetStopHour1) StopTrading = false;
            }
            if (offsetStopHour1 >=0)
            {
              if ( Hour() <= offsetStopHour1) StopTrading = false;
            }
          }
        }
        else
        {
          if (Hour() >= offsetStartHour1 && Hour() <= offsetStopHour1) StopTrading = false;
        }
     }
     if (StopTrading)
     {
//------------------------------ Check trading European Market------------------------//
       if (TradeEuropeanMarket)
       {
         if (Hour() >= offsetStartHour2 && Hour() <= offsetStopHour2) StopTrading = false;
       }
     }
     if (StopTrading)
     {
// Check trading New York Market
       if (TradeNewYorkMarket)
       {
         if (Hour() >= offsetStartHour3 && Hour() <= offsetStopHour3) StopTrading = false;
       }
     }
     
     return(StopTrading);
     
}
int start()
{
/*
//--------------------------------E W O---------------------------------------//

double  EWO=iCustom(Symbol(),Period(),"Elliott_Wave_Oscillator",0,1);
double  EWOPrev=iCustom(Symbol(),Period(),"Elliott_Wave_Oscillator",0,2); 

//--------------------------------C C I---------------------------------------//

double  cci1=iCCI( NULL, 0, CCI_PeriodFast, PRICE_TYPICAL, 0);
double  cci1Pev=iCCI( NULL, 0, CCI_PeriodFast, PRICE_TYPICAL, 1); 

//-------------------------------RSI Slope------------------------------------//

double  RSI = iRSI(NULL, 0, 12, PRICE_MEDIAN, 0);
double  RSIPrev = iRSI(NULL, 0,12, PRICE_MEDIAN, 1);

//--------------------------------8/55 MA-------------------------------------//

double  Ma8=iMA(NULL,0,8,0,MODE_LWMA,PRICE_WEIGHTED,0);        
double  Ma8Prev=iMA(NULL,0,8,0,MODE_LWMA,PRICE_WEIGHTED,1);
double  Ma55=iMA(NULL,0,55,0,MODE_EMA,PRICE_TYPICAL,0);
double  Ma55Prev=iMA(NULL,0,55,0,MODE_EMA,PRICE_TYPICAL,1);

//--------------------------------200 SMA-------------------------------------//

double  maLarge=iMA(NULL,0,200,0,MODE_SMA,PRICE_MEDIAN,1);
*/
//--------------------------------Volume--------------------------------------//

double  mav=iVolume(Symbol(),Period(),0)/2;

//------------------------------Pivot/Daily/Bars------------------------------//

PrevDClose   = iClose(Symbol(),PERIOD_D1,1);
PrevDCloseP   = iClose(Symbol(),PERIOD_D1,2);
PrevDHighP    = iHigh(Symbol(),PERIOD_D1,2);
PrevDLowP     = iLow(Symbol(),PERIOD_D1,2);
YPivot        = (PrevDHighP + PrevDLowP + PrevDCloseP)/3;
BarClose     = iClose(Symbol(),Period(),0);                        
BarClosePrev = iClose(Symbol(),Period(),1); 
PrevBarHigh  = High[1];
PrevBarLow   = Low[1];


//---------------------Close Trade On Reverse Signal-----------------------------//
/*
if(RSI < 40 && OrderType()==OP_BUY )
 {
  for(MyTrades = 0; MyTrades <OrdersTotal(); MyTrades++)
   {
    OrderSelect(MyTrades,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol() == Symbol() && OrderType()== OP_BUY) 
      {
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Orange);
          {
          err=GetLastError();
          Print("Error(",err,"): RSI Closeing BUY Trade ",ErrorDescription(err));
          RefreshRates();
          
          OpenLong=false;
          }
              
      }
   }
}  
    

if(RSI > 60 && OrderType()==OP_SELL)
 {
  for(MyTrades = 0; MyTrades <OrdersTotal(); MyTrades++)
   {
    OrderSelect(MyTrades,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol() == Symbol() && OrderType()== OP_SELL) 
      {
   OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Yellow);
          {
          
          err=GetLastError();
          Print("Error(",err,"): RSI Closing SELL Trade",ErrorDescription(err));
          RefreshRates();
          
          OpenShort=false;
          }
              
      }
   }
}  
*/ 
//----------Lets Get Min. S/L Distance Allowed By Broker-------------------------//
int     day; 
int     S_StopLoss;
int     L_StopLoss;
int err;
err=GetLastError();
double dblMinStopDistance = MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(), MODE_POINT);
Comment ("Min Stop Distance : ",dblMinStopDistance,"    ","MaVolume :",mav);  
int NumTrades = 0;
int OpenLong,OpenShort; 
  for (int i = 0; i < OrdersTotal(); i++)
  {
    OrderSelect(i, SELECT_BY_POS);
 
    if (OrderSymbol() == Symbol())
    {
      if (OrderType() == OP_BUY ) NumTrades++;
      if (OrderType() == OP_SELL )NumTrades++;
    }
  }
  
//---------------------------Lets Determine Lot Size---------------------------//
 
L_StopLoss = iLow(Symbol(),PERIOD_D1,0);
S_StopLoss = iHigh(Symbol(),PERIOD_D1,0);
if (NumTrades == 0) 
 {
    if (TradeAllowed)
      {
          if (MM_Type == 1)
            Lotsi = MoneyManagement ( UseMoneyManagement, Lots, MMRisk, LossMax);
          else
            Lotsi = GetLots();
//-----------------------------Is It Time To Trade?----------------------------//          
               YesStop = false;
   if (UseTradingHours) YesStop = CheckTradingTimes();
   
   if (YesStop)
   {
      Comment ("Trading has been stopped as requested - wrong time of day");
      
   }
 //----------------------------------SIGNAL GENERATOR--------------------------//           
          //----Long-------------------//
         
         if (BarClosePrev > YPivot && BarClose < YPivot && BarClose < BarClosePrev && PrevDClose < YPivot)
         OrderSend(Symbol(), OP_BUY, Lotsi, Ask, Slippage, Ask - StopLoss * Point, Ask + ProfitTarget * Point, 0); 
        
        
          //----Short--------------------//
        
          if (BarClosePrev < YPivot && BarClose > YPivot && BarClose > BarClosePrev && PrevDClose > YPivot)
          OrderSend(Symbol(), OP_SELL, Lotsi, Bid, Slippage, Bid + StopLoss * Point, Bid - ProfitTarget * Point, 0);
       
        
            {
             return(0);
           }
        }
     }
     
//------------------------------TRAILING STOP FUNCTION-------------------------//  
  if (UseTrailingStop)
   {
    for (i = 0; i < OrdersTotal(); i++)
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);

     if ( OrderSymbol() == Symbol() )
      {
       if ( OrderType() == OP_BUY )
        {
          HandleTrailingStop(OP_BUY,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
          }

      if ( OrderType() == OP_SELL)
         {
          HandleTrailingStop(OP_SELL,OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderTakeProfit());
	  	  }
	   }
    }

}
return(0);
}

// ---------------------------------- Money Management, by Robert Hill--------------------//

double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
   {
     Lotsi=Lots;
	    
   if ( flag ) Lotsi=NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
} 

//-------------------------------------Lets Determine Lot Size---------------------------//                             

double GetLots()
{
   double lot;
   
   if(UseMoneyManagement)
    {
     lot = LotsOptimized();
      }
       else
        {
         lot = Lots;
   
   
   if(AccountIsMini)
    {
     if (lot < 0.1) lot = 0.1;
      }
       else
      {
     if (lot >= 1.0) lot = MathFloor(lot); else lot = 1.0;
      }
       if (lot > MaxLots) lot = MaxLots;
        }
         return(lot);
        }




//------------------ Calculate optimal lot size based on percent of Account---------------//                                   


double LotsOptimized()
  {
   double lot=Lots;
//---- select lot size
   lot=NormalizeDouble(MathFloor(AccountFreeMargin()*TradeSizePercent/10000)/10,1);
   
  
  if(AccountIsMini)
  {
    lot = MathFloor(lot*10)/10;
    
   }
   return(lot);
  }
  


//-------------- Modify Open Position Controls  Try to modify position 3 times -----------//                                 

bool ModifyOrder(int nOrderType, int ord_ticket,double op, double price,double tp, color mColor = CLR_NONE)
{
    int cnt, err;
    double myStop;
    
    myStop = ValidStopLoss (nOrderType, price);
    cnt=0;
   
       if (OrderModify(ord_ticket,op,myStop,tp,0,mColor))
       {
         return(true);
       }
       else 
       {
          err=GetLastError();
          if (err > 1) Print(cnt," Error modifying order : (", ord_ticket , ") " + ErrorDescription(err), " err ",err);
          if (err>0) cnt++;
          Sleep (10000);
          }
       
    
    return(false);
}



//---------------------------------Adjust stop loss so that it is legal------------------//
double ValidStopLoss(int cmd, double sl)
{
   
   if (sl == 0) return(0.0);
   
   double mySL, myPrice;
   double dblMinStopDistance = MarketInfo(Symbol(),MODE_STOPLEVEL)*MarketInfo(Symbol(), MODE_POINT);
   mySL = sl;
// Check if SlopLoss needs to be modified

   switch(cmd)
   {
   case OP_BUY:
      myPrice = MarketInfo(Symbol(), MODE_BID);
	   if (myPrice - sl < dblMinStopDistance)
	    
		mySL = myPrice - dblMinStopDistance;	// we are long
		break;
      
   case OP_SELL:
      myPrice = MarketInfo(Symbol(), MODE_ASK);
	   if (sl - myPrice < dblMinStopDistance) 
		mySL = myPrice + dblMinStopDistance;	// we are Short
      
      
   }
   return(NormalizeDouble(mySL,MarketInfo(Symbol(), MODE_DIGITS)));
}



//+------------------------------------------------------------------+
//| HandleTrailingStop                                               |
//| Type 1 moves the stoploss without delay.                         |
//| Type 2 waits for price to move the amount of the trailStop       |
//| before moving stop loss then moves like type 1                   |     |          |
//+------------------------------------------------------------------+
int HandleTrailingStop(int type, int ticket, double op, double os, double tp)
{
    double pt, TS=0, myAsk, myBid;
    double bos,bop,opa,osa;
    
    switch(type)
    {
       case OP_BUY:
       {
		 myBid = MarketInfo(Symbol(),MODE_BID);
       switch(TrailingStopType)
       {
        case 1: pt = Point*StopLoss;
                if(myBid-os > pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
        case 2: pt = Point*TrailingStop;
                if(myBid-op > pt && os < myBid - pt)
                 ModifyOrder(type, ticket,op,myBid-pt,tp, Aqua);
                break;
       }
       return(0);
       break;
       }
    case  OP_SELL:
    {
		myAsk = MarketInfo(Symbol(),MODE_ASK);
       switch(TrailingStopType)
       {
        case 1: pt = Point*StopLoss;
                if(os - myAsk > pt)
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                break;
        case 2: pt = Point*TrailingStop;
                if(op - myAsk > pt && os > myAsk+pt)
                 ModifyOrder(type, ticket,op,myAsk+pt,tp, Aqua);
                break;
       }
    }
    return(0);
    }
}  
//----------------- Time frame interval appropriation  function----------------------//

int func_TimeFrame_Const2Val(int Constant ) {
   switch(Constant) {
      case 1:  // M1
         return(1);
      case 5:  // M5
         return(2);
      case 15:
         return(3);
      case 30:
         return(4);
      case 60:
         return(5);
      case 240:
         return(6);
      case 1440:
         return(7);
      case 10080:
         return(8);
      case 43200:
         return(9);
   }
}
int func_Symbol2Val(string symbol) {
   string mySymbol = StringSubstr(symbol,0,6);
	if(mySymbol=="AUDCAD") return(1);
	if(mySymbol=="AUDJPY") return(2);
	if(mySymbol=="AUDNZD") return(3);
	if(mySymbol=="AUDUSD") return(4);
	if(mySymbol=="CHFJPY") return(5);
	if(mySymbol=="EURAUD") return(6);
	if(mySymbol=="EURCAD") return(7);
	if(mySymbol=="EURCHF") return(8);
	if(mySymbol=="EURGBP") return(9);
	if(mySymbol=="EURJPY") return(10);
	if(mySymbol=="EURUSD") return(11);
	if(mySymbol=="GBPCHF") return(12);
	if(mySymbol=="GBPJPY") return(13);
	if(mySymbol=="GBPUSD") return(14);
	if(mySymbol=="NZDUSD") return(15);
	if(mySymbol=="USDCAD") return(16);
	if(mySymbol=="USDCHF") return(17);
	if(mySymbol=="USDJPY") return(18);
	Comment("unexpected Symbol");
	return(19);
}


